import processing.serial.*;
import cc.arduino.*;
import org.philhosoft.p8g.svg.P8gGraphicsSVG;

float hautdroite;
float hautgauche;
float basdroite;
float basgauche;
float depX = 400;
float depY = 300;
float pdepX = 400;
float pdepY = 300;
int i=1;
int captOD;
int captOG;
int captBD;
int captBG;
int posX =30;
int posY = 100;
Boolean doubl = false;

Arduino arduino;
P8gGraphicsSVG svg;

void setup() {
  size (800, 600);
  svg = (P8gGraphicsSVG) createGraphics(width, height, P8gGraphicsSVG.SVG, i+"fraise");
  beginRecord(svg);
  smooth();
  println(Serial.list());
  arduino = new Arduino(this, Arduino.list()[0], 57600);
  frameRate(30);
  arduino.pinMode(0, Arduino.INPUT);
  arduino.pinMode(1, Arduino.INPUT);
  arduino.pinMode(2, Arduino.INPUT);
  arduino.pinMode(3, Arduino.INPUT);
  background(255);
  depX = width/2;
  depY = height/2;
}

void draw() {
 
  //svg = (P8gGraphicsSVG) createGraphics(width, height, P8gGraphicsSVG.SVG, i+"fraise");
  captOD = (arduino.analogRead(0));
  captOG = (arduino.analogRead(1));
  captBG = (arduino.analogRead(2));
  captBD = (arduino.analogRead(3));
  println("BD : "+captBD);
  //println("BG : "+captBG);
  //println("OG : "+captOG);
  //println("OD : "+captOD);
 
  //////////// capteurs ////////////
 
  basdroite =captBD;
  basdroite=constrain(basdroite, 0, 300);
  basdroite=map(basdroite, 60, 290, 0, 255);
  basgauche = captBG;
  basgauche=constrain(basgauche, 30, 160);
  basgauche=map(basgauche, 30, 150, 0, 255);
  hautdroite = captOD;
  hautdroite=constrain(hautdroite, 8, 230);
  hautdroite=map(hautdroite, 8, 220, 0, 255);
  hautgauche = captOG;
  hautgauche=constrain(hautgauche, 4, 200);
  hautgauche=map(hautgauche, 4, 190  , 0, 255);
  //hautgauche=map(hautgauche, 0, 1023, 0, 255);
  fill(hautgauche,0,0); 
  noStroke();
  rect(20,20,20,20);
    fill(hautdroite,0,0); 
  noStroke();
  rect(50,20,20,20);
    fill(basgauche,0,0); 
  noStroke();
  rect(20,60,20,20);
    fill(basdroite,0,0); 
  noStroke();
  rect(50,60,20,20);
  
  //////////////////////////////////
 if (depX >= width-10) depX = width-10;
 if (depX <= 10) depX = 10;
 if (depY >= height-10) depY = height-10;
 if (depY <= 10) depY = 10;
 
 if (hautgauche >=100) {
   depX-= (hautgauche/50);
   depY-= (hautgauche/50);
 }
  if (hautdroite >=100) {
   depX+= (hautdroite/50);
   depY-= (hautdroite/50);
 }
 if (basdroite >=100) {
   depX+= (basdroite/50);
   depY+= (basdroite/50);
 }
 if (basgauche >=100) {
   depX-= (basgauche/50);
   depY+= (basgauche/50);
 }
 
 if (depX >= width-10) depX = width-10;
 if (depX <= 10) depX = 10;
 if (depY >= height-10) depY = height-10;
 if (depY <= 10) depY = 10;
 //////////// dessin //////////////
 
 
 strokeWeight(5);
 stroke(33,66,99);
 line(pdepX, pdepY, depX, depY);
 pdepX = depX;
 pdepY = depY;

  if (keyPressed) {
    if (key == 'e' || key == 'E') {
      background (255);
    }
  }
  
}
